##// END OF EJS Templates
a
Unknown -
r474:f41d2e7406fd
parent child
Show More
@@ -1,854 +1,854
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63 # Kernel deb packages for 32bit kernel
64 64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 68 # Default precompiled 64bit kernel
69 69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 70 # Generic
71 71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 72
73 73 # Build directories
74 74 WORKDIR=$(pwd)
75 75 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
76 76 BUILDDIR="${BASEDIR}/build"
77 77
78 78 # Chroot directories
79 79 R="${BUILDDIR}/chroot"
80 80 ETC_DIR="${R}/etc"
81 81 LIB_DIR="${R}/lib"
82 82 BOOT_DIR="${R}/boot/firmware"
83 83 KERNEL_DIR="${R}/usr/src/linux"
84 84 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
85 85 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
86 86
87 87 # Firmware directory: Blank if download from github
88 88 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
89 89
90 90 # General settings
91 91 SET_ARCH=${SET_ARCH:=32}
92 92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
93 93 PASSWORD=${PASSWORD:=raspberry}
94 94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
95 95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
96 96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
97 97 EXPANDROOT=${EXPANDROOT:=true}
98 98
99 99 # Keyboard settings
100 100 XKB_MODEL=${XKB_MODEL:=""}
101 101 XKB_LAYOUT=${XKB_LAYOUT:=""}
102 102 XKB_VARIANT=${XKB_VARIANT:=""}
103 103 XKB_OPTIONS=${XKB_OPTIONS:=""}
104 104
105 105 # Network settings (DHCP)
106 106 ENABLE_DHCP=${ENABLE_DHCP:=true}
107 107
108 108 # Network settings (static)
109 109 NET_ADDRESS=${NET_ADDRESS:=""}
110 110 NET_GATEWAY=${NET_GATEWAY:=""}
111 111 NET_DNS_1=${NET_DNS_1:=""}
112 112 NET_DNS_2=${NET_DNS_2:=""}
113 113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
114 114 NET_NTP_1=${NET_NTP_1:=""}
115 115 NET_NTP_2=${NET_NTP_2:=""}
116 116
117 117 # APT settings
118 118 APT_PROXY=${APT_PROXY:=""}
119 119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
120 120
121 121 # Feature settings
122 122 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
123 123 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
124 124 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
125 125 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
126 126 ENABLE_I2C=${ENABLE_I2C:=false}
127 127 ENABLE_SPI=${ENABLE_SPI:=false}
128 128 ENABLE_IPV6=${ENABLE_IPV6:=true}
129 129 ENABLE_SSHD=${ENABLE_SSHD:=true}
130 130 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
131 131 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
132 132 ENABLE_SOUND=${ENABLE_SOUND:=true}
133 133 ENABLE_DBUS=${ENABLE_DBUS:=true}
134 134 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
135 135 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
136 136 ENABLE_XORG=${ENABLE_XORG:=false}
137 137 ENABLE_WM=${ENABLE_WM:=""}
138 138 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
139 139 ENABLE_USER=${ENABLE_USER:=true}
140 140 USER_NAME=${USER_NAME:="pi"}
141 141 ENABLE_ROOT=${ENABLE_ROOT:=false}
142 142 ENABLE_QEMU=${ENABLE_QEMU:=false}
143 143 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
144 144
145 145 # SSH settings
146 146 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
147 147 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
148 148 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
149 149 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
150 150 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
151 151
152 152 # Advanced settings
153 153 ENABLE_SYSTEMDSWAP=${ENABLE_MINBASE:=false}
154 154 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
155 155 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
156 156 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
157 157 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
158 158 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
159 159 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
160 160 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
161 161 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
162 162 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
163 163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
164 164 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
165 165 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
166 166 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
167 167 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
168 168 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
169 169 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
170 170 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
171 171
172 172 # Kernel compilation settings
173 173 BUILD_KERNEL=${BUILD_KERNEL:=true}
174 174 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
175 175 KERNEL_THREADS=${KERNEL_THREADS:=1}
176 176 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
177 177 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
178 178 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
179 179 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
180 180 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
181 181 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
182 182 KERNEL_VIRT=${KERNEL_VIRT:=false}
183 183 KERNEL_BPF=${KERNEL_BPF:=false}
184 184 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=POWERSAVE}
185 185
186 186 # Kernel compilation from source directory settings
187 187 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
188 188 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
189 189 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
190 190 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
191 191
192 192 # Reduce disk usage settings
193 193 REDUCE_APT=${REDUCE_APT:=true}
194 194 REDUCE_DOC=${REDUCE_DOC:=true}
195 195 REDUCE_MAN=${REDUCE_MAN:=true}
196 196 REDUCE_VIM=${REDUCE_VIM:=false}
197 197 REDUCE_BASH=${REDUCE_BASH:=false}
198 198 REDUCE_HWDB=${REDUCE_HWDB:=true}
199 199 REDUCE_SSHD=${REDUCE_SSHD:=true}
200 200 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
201 201
202 202 # Encrypted filesystem settings
203 203 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
204 204 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
205 205 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
206 206 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
207 207 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
208 208 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
209 209 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
210 210 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
211 211 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
212 212
213 213 # Chroot scripts directory
214 214 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
215 215
216 216 # Packages required in the chroot build environment
217 217 APT_INCLUDES=${APT_INCLUDES:=""}
218 218 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
219 219
220 220 #Packages to exclude from chroot build environment
221 221 APT_EXCLUDES=${APT_EXCLUDES:=""}
222 222
223 223 # Packages required for bootstrapping
224 224 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
225 225 MISSING_PACKAGES=""
226 226
227 227 # Packages installed for c/c++ build environment in chroot (keep empty)
228 228 COMPILER_PACKAGES=""
229 229
230 230 #Check if apt-cacher-ng has port 3142 open and set APT_PROXY
231 231 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
232 232 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
233 233 APT_PROXY=http://127.0.0.1:3142/
234 234 fi
235 235
236 236 #netselect-apt does not know buster yet
237 237 if [ "$RELEASE" = "buster" ] ; then
238 238 RLS=testing
239 239 else
240 240 RLS="$RELEASE"
241 241 fi
242 242
243 243 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
244 244 rm "$(pwd)/files/apt/sources.list"
245 245 fi
246 246
247 247 if [ "$ENABLE_NONFREE" = true ] ; then
248 248 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
249 249 else
250 250 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
251 251 fi
252 252
253 253 #sed and cut the result string so we can use it as APT_SERVER
254 254 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
255 255
256 256 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
257 257 if [ -n "$SET_ARCH" ] ; then
258 258 # 64 bit configuration
259 259 if [ "$SET_ARCH" = 64 ] ; then
260 260 # General 64 bit depended settings
261 261 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
262 262 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
263 263 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
264 264
265 265 # Board specific settings
266 266 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
267 267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
268 268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
269 269 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
270 270 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
271 271 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
272 272 else
273 273 echo "error: Only Raspberry PI 3 and 3B+ support 64 bit"
274 274 exit 1
275 275 fi
276 276 fi
277 277
278 278 # 32 bit configuration
279 279 if [ "$SET_ARCH" = 32 ] ; then
280 280 # General 32 bit dependend settings
281 281 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
282 282 KERNEL_ARCH=${KERNEL_ARCH:=arm}
283 283 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
284 284
285 285 # Hardware specific settings
286 286 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
287 287 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
288 288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
289 289 RELEASE_ARCH=${RELEASE_ARCH:=armel}
290 290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
291 291 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
292 292 fi
293 293
294 294 # Hardware specific settings
295 295 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
296 296 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
297 297 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
298 298 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
299 299 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
300 300 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
301 301 fi
302 302 fi
303 303 #SET_ARCH not set
304 304 else
305 305 echo "error: Please set '32' or '64' as value for SET_ARCH"
306 306 exit 1
307 307 fi
308 308 # Device specific configuration and U-Boot configuration
309 309 case "$RPI_MODEL" in
310 310 0)
311 311 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
312 312 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
313 313 ;;
314 314 1)
315 315 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
316 316 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
317 317 ;;
318 318 1P)
319 319 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
320 320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
321 321 ;;
322 322 2)
323 323 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
324 324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
325 325 ;;
326 326 3)
327 327 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
328 328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
329 329 ;;
330 330 3P)
331 331 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
332 332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
333 333 ;;
334 334 *)
335 335 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
336 336 exit 1
337 337 ;;
338 338 esac
339 339
340 340 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
341 341 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
342 342 # Include bluetooth packages on supported boards
343 343 if [ "$ENABLE_BLUETOOTH" = true ] && [ "$ENABLE_CONSOLE" = false ]; then
344 344 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
345 345 fi
346 346 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
347 347 # Check if the internal wireless interface is not supported by the RPi model
348 348 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
349 349 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
350 350 exit 1
351 351 fi
352 352 fi
353 353
354 354 # Prepare date string for default image file name
355 355 DATE="$(date +%Y-%m-%d)"
356 356 if [ -z "$KERNEL_BRANCH" ] ; then
357 357 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
358 358 else
359 359 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
360 360 fi
361 361
362 362 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
363 363 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
364 364 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
365 365 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
366 366 exit 1
367 367 fi
368 368 fi
369 369
370 370 set +x
371 371
372 372 # Add cmake to compile videocore sources
373 373 if [ "$ENABLE_VIDEOCORE" = true ] ; then
374 374 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
375 375 fi
376 376
377 377 # Add deps for nexmon
378 378 if [ "$ENABLE_NEXMON" = true ] ; then
379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES},libgmp3-dev,gawk,qpdf,bison,flex,make,autoconf,automake,build-essential,libtool"
379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
380 380 fi
381 381
382 382 # Add libncurses5 to enable kernel menuconfig
383 383 if [ "$KERNEL_MENUCONFIG" = true ] ; then
384 384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
385 385 fi
386 386
387 387 # Add ccache compiler cache for (faster) kernel cross (re)compilation
388 388 if [ "$KERNEL_CCACHE" = true ] ; then
389 389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
390 390 fi
391 391
392 392 # Add cryptsetup package to enable filesystem encryption
393 393 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
394 394 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
395 395 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
396 396
397 397 #If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
398 398 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
399 399 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
400 400 fi
401 401
402 402 if [ -z "$CRYPTFS_PASSWORD" ] ; then
403 403 echo "error: no password defined (CRYPTFS_PASSWORD)!"
404 404 exit 1
405 405 fi
406 406 ENABLE_INITRAMFS=true
407 407 fi
408 408
409 409 # Add initramfs generation tools
410 410 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
411 411 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
412 412 fi
413 413
414 414 # Add device-tree-compiler required for building the U-Boot bootloader
415 415 if [ "$ENABLE_UBOOT" = true ] ; then
416 416 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
417 417 else
418 418 if [ "$ENABLE_UBOOTUSB" = true ] ; then
419 419 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
420 420 exit 1
421 421 fi
422 422 fi
423 423
424 424 # Check if root SSH (v2) public key file exists
425 425 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
426 426 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
427 427 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
428 428 exit 1
429 429 fi
430 430 fi
431 431
432 432 # Check if $USER_NAME SSH (v2) public key file exists
433 433 if [ -n "$SSH_USER_PUB_KEY" ] ; then
434 434 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
435 435 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
436 436 exit 1
437 437 fi
438 438 fi
439 439
440 440 # Check if all required packages are installed on the build system
441 441 for package in $REQUIRED_PACKAGES ; do
442 442 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
443 443 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
444 444 fi
445 445 done
446 446
447 447 # If there are missing packages ask confirmation for install, or exit
448 448 if [ -n "$MISSING_PACKAGES" ] ; then
449 449 echo "the following packages needed by this script are not installed:"
450 450 echo "$MISSING_PACKAGES"
451 451
452 452 printf "\ndo you want to install the missing packages right now? [y/n] "
453 453 read -r confirm
454 454 [ "$confirm" != "y" ] && exit 1
455 455
456 456 # Make sure all missing required packages are installed
457 457 apt-get -qq -y install "${MISSING_PACKAGES}"
458 458 fi
459 459
460 460 # Check if ./bootstrap.d directory exists
461 461 if [ ! -d "./bootstrap.d/" ] ; then
462 462 echo "error: './bootstrap.d' required directory not found!"
463 463 exit 1
464 464 fi
465 465
466 466 # Check if ./files directory exists
467 467 if [ ! -d "./files/" ] ; then
468 468 echo "error: './files' required directory not found!"
469 469 exit 1
470 470 fi
471 471
472 472 # Check if specified KERNELSRC_DIR directory exists
473 473 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
474 474 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
475 475 exit 1
476 476 fi
477 477
478 478 # Check if specified UBOOTSRC_DIR directory exists
479 479 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
480 480 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
481 481 exit 1
482 482 fi
483 483
484 484 # Check if specified VIDEOCORESRC_DIR directory exists
485 485 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
486 486 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
487 487 exit 1
488 488 fi
489 489
490 490 # Check if specified FBTURBOSRC_DIR directory exists
491 491 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
492 492 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
493 493 exit 1
494 494 fi
495 495
496 496 # Check if specified NEXMONSRC_DIR directory exists
497 497 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
498 498 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
499 499 exit 1
500 500 fi
501 501
502 502 # Check if specified CHROOT_SCRIPTS directory exists
503 503 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
504 504 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
505 505 exit 1
506 506 fi
507 507
508 508 # Check if specified device mapping already exists (will be used by cryptsetup)
509 509 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
510 510 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
511 511 exit 1
512 512 fi
513 513
514 514 # Don't clobber an old build
515 515 if [ -e "$BUILDDIR" ] ; then
516 516 echo "error: directory ${BUILDDIR} already exists, not proceeding"
517 517 exit 1
518 518 fi
519 519
520 520 # Setup chroot directory
521 521 mkdir -p "${R}"
522 522
523 523 # Check if build directory has enough of free disk space >512MB
524 524 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
525 525 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
526 526 exit 1
527 527 fi
528 528
529 529 set -x
530 530
531 531 # Call "cleanup" function on various signals and errors
532 532 trap cleanup 0 1 2 3 6
533 533
534 534 # Add required packages for the minbase installation
535 535 if [ "$ENABLE_MINBASE" = true ] ; then
536 536 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
537 537 fi
538 538
539 539 # Add parted package, required to get partprobe utility
540 540 if [ "$EXPANDROOT" = true ] ; then
541 541 APT_INCLUDES="${APT_INCLUDES},parted"
542 542 fi
543 543
544 544 # Add dbus package, recommended if using systemd
545 545 if [ "$ENABLE_DBUS" = true ] ; then
546 546 APT_INCLUDES="${APT_INCLUDES},dbus"
547 547 fi
548 548
549 549 # Add iptables IPv4/IPv6 package
550 550 if [ "$ENABLE_IPTABLES" = true ] ; then
551 551 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
552 552 fi
553 553
554 554 # Add openssh server package
555 555 if [ "$ENABLE_SSHD" = true ] ; then
556 556 APT_INCLUDES="${APT_INCLUDES},openssh-server"
557 557 fi
558 558
559 559 # Add alsa-utils package
560 560 if [ "$ENABLE_SOUND" = true ] ; then
561 561 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
562 562 fi
563 563
564 564 # Add rng-tools package
565 565 if [ "$ENABLE_HWRANDOM" = true ] ; then
566 566 APT_INCLUDES="${APT_INCLUDES},rng-tools"
567 567 fi
568 568
569 569 # Add fbturbo video driver
570 570 if [ "$ENABLE_FBTURBO" = true ] ; then
571 571 # Enable xorg package dependencies
572 572 ENABLE_XORG=true
573 573 fi
574 574
575 575 # Add user defined window manager package
576 576 if [ -n "$ENABLE_WM" ] ; then
577 577 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
578 578
579 579 # Enable xorg package dependencies
580 580 ENABLE_XORG=true
581 581 fi
582 582
583 583 # Add xorg package
584 584 if [ "$ENABLE_XORG" = true ] ; then
585 585 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
586 586 fi
587 587
588 588 # Replace selected packages with smaller clones
589 589 if [ "$ENABLE_REDUCE" = true ] ; then
590 590 # Add levee package instead of vim-tiny
591 591 if [ "$REDUCE_VIM" = true ] ; then
592 592 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
593 593 fi
594 594
595 595 # Add dropbear package instead of openssh-server
596 596 if [ "$REDUCE_SSHD" = true ] ; then
597 597 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
598 598 fi
599 599 fi
600 600
601 601 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
602 602 if [ "$ENABLE_SYSVINIT" = false ] ; then
603 603 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
604 604 fi
605 605
606 606 # Configure kernel sources if no KERNELSRC_DIR
607 607 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
608 608 KERNELSRC_CONFIG=true
609 609 fi
610 610
611 611 # Configure reduced kernel
612 612 if [ "$KERNEL_REDUCE" = true ] ; then
613 613 KERNELSRC_CONFIG=false
614 614 fi
615 615
616 616 # Configure qemu compatible kernel
617 617 if [ "$ENABLE_QEMU" = true ] ; then
618 618 DTB_FILE=vexpress-v2p-ca15_a7.dtb
619 619 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
620 620 KERNEL_DEFCONFIG="vexpress_defconfig"
621 621 if [ "$KERNEL_MENUCONFIG" = false ] ; then
622 622 KERNEL_OLDDEFCONFIG=true
623 623 fi
624 624 fi
625 625
626 626 # Execute bootstrap scripts
627 627 for SCRIPT in bootstrap.d/*.sh; do
628 628 head -n 3 "$SCRIPT"
629 629 . "$SCRIPT"
630 630 done
631 631
632 632 ## Execute custom bootstrap scripts
633 633 if [ -d "custom.d" ] ; then
634 634 for SCRIPT in custom.d/*.sh; do
635 635 . "$SCRIPT"
636 636 done
637 637 fi
638 638
639 639 # Execute custom scripts inside the chroot
640 640 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
641 641 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
642 642 chroot_exec /bin/bash -x <<'EOF'
643 643 for SCRIPT in /chroot_scripts/* ; do
644 644 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
645 645 $SCRIPT
646 646 fi
647 647 done
648 648 EOF
649 649 rm -rf "${R}/chroot_scripts"
650 650 fi
651 651
652 652 # Remove c/c++ build environment from the chroot
653 653 chroot_remove_cc
654 654
655 655 # Generate required machine-id
656 656 MACHINE_ID=$(dbus-uuidgen)
657 657 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
658 658 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
659 659
660 660 # APT Cleanup
661 661 chroot_exec apt-get -y clean
662 662 chroot_exec apt-get -y autoclean
663 663 chroot_exec apt-get -y autoremove
664 664
665 665 # Unmount mounted filesystems
666 666 umount -l "${R}/proc"
667 667 umount -l "${R}/sys"
668 668
669 669 # Clean up directories
670 670 rm -rf "${R}/run/*"
671 671 rm -rf "${R}/tmp/*"
672 672
673 673 # Clean up files
674 674 rm -f "${ETC_DIR}/ssh/ssh_host_*"
675 675 rm -f "${ETC_DIR}/dropbear/dropbear_*"
676 676 rm -f "${ETC_DIR}/apt/sources.list.save"
677 677 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
678 678 rm -f "${ETC_DIR}/*-"
679 679 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
680 680 rm -f "${ETC_DIR}/resolv.conf"
681 681 rm -f "${R}/root/.bash_history"
682 682 rm -f "${R}/var/lib/urandom/random-seed"
683 683 rm -f "${R}/initrd.img"
684 684 rm -f "${R}/vmlinuz"
685 685 rm -f "${R}${QEMU_BINARY}"
686 686
687 687 if [ "$ENABLE_QEMU" = true ] ; then
688 688 # Setup QEMU directory
689 689 mkdir "${BASEDIR}/qemu"
690 690
691 691 # Copy kernel image to QEMU directory
692 692 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
693 693
694 694 # Copy kernel config to QEMU directory
695 695 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
696 696
697 697 # Copy kernel dtbs to QEMU directory
698 698 for dtb in "${BOOT_DIR}/"*.dtb ; do
699 699 if [ -f "${dtb}" ] ; then
700 700 install_readonly "${dtb}" "${BASEDIR}/qemu/"
701 701 fi
702 702 done
703 703
704 704 # Copy kernel overlays to QEMU directory
705 705 if [ -d "${BOOT_DIR}/overlays" ] ; then
706 706 # Setup overlays dtbs directory
707 707 mkdir "${BASEDIR}/qemu/overlays"
708 708
709 709 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
710 710 if [ -f "${dtb}" ] ; then
711 711 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
712 712 fi
713 713 done
714 714 fi
715 715
716 716 # Copy u-boot files to QEMU directory
717 717 if [ "$ENABLE_UBOOT" = true ] ; then
718 718 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
719 719 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
720 720 fi
721 721 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
722 722 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
723 723 fi
724 724 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
725 725 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
726 726 fi
727 727 fi
728 728
729 729 # Copy initramfs to QEMU directory
730 730 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
731 731 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
732 732 fi
733 733 fi
734 734
735 735 # Calculate size of the chroot directory in KB
736 736 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
737 737
738 738 # Calculate the amount of needed 512 Byte sectors
739 739 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
740 740 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
741 741 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
742 742
743 743 # The root partition is EXT4
744 744 # This means more space than the actual used space of the chroot is used.
745 745 # As overhead for journaling and reserved blocks 35% are added.
746 746 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
747 747
748 748 # Calculate required image size in 512 Byte sectors
749 749 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
750 750
751 751 # Prepare image file
752 752 if [ "$ENABLE_SPLITFS" = true ] ; then
753 753 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
754 754 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
755 755 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
756 756 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
757 757
758 758 # Write firmware/boot partition tables
759 759 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
760 760 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
761 761 EOM
762 762
763 763 # Write root partition table
764 764 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
765 765 ${TABLE_SECTORS},${ROOT_SECTORS},83
766 766 EOM
767 767
768 768 # Setup temporary loop devices
769 769 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
770 770 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
771 771 else # ENABLE_SPLITFS=false
772 772 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
773 773 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
774 774
775 775 # Write partition table
776 776 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
777 777 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
778 778 ${ROOT_OFFSET},${ROOT_SECTORS},83
779 779 EOM
780 780
781 781 # Setup temporary loop devices
782 782 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
783 783 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
784 784 fi
785 785
786 786 if [ "$ENABLE_CRYPTFS" = true ] ; then
787 787 # Create dummy ext4 fs
788 788 mkfs.ext4 "$ROOT_LOOP"
789 789
790 790 # Setup password keyfile
791 791 touch .password
792 792 chmod 600 .password
793 793 echo -n ${CRYPTFS_PASSWORD} > .password
794 794
795 795 # Initialize encrypted partition
796 796 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
797 797
798 798 # Open encrypted partition and setup mapping
799 799 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
800 800
801 801 # Secure delete password keyfile
802 802 shred -zu .password
803 803
804 804 # Update temporary loop device
805 805 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
806 806
807 807 # Wipe encrypted partition (encryption cipher is used for randomness)
808 808 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
809 809 fi
810 810
811 811 # Build filesystems
812 812 mkfs.vfat "$FRMW_LOOP"
813 813 mkfs.ext4 "$ROOT_LOOP"
814 814
815 815 # Mount the temporary loop devices
816 816 mkdir -p "$BUILDDIR/mount"
817 817 mount "$ROOT_LOOP" "$BUILDDIR/mount"
818 818
819 819 mkdir -p "$BUILDDIR/mount/boot/firmware"
820 820 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
821 821
822 822 # Copy all files from the chroot to the loop device mount point directory
823 823 rsync -a "${R}/" "$BUILDDIR/mount/"
824 824
825 825 # Unmount all temporary loop devices and mount points
826 826 cleanup
827 827
828 828 # Create block map file(s) of image(s)
829 829 if [ "$ENABLE_SPLITFS" = true ] ; then
830 830 # Create block map files for "bmaptool"
831 831 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
832 832 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
833 833
834 834 # Image was successfully created
835 835 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
836 836 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
837 837 else
838 838 # Create block map file for "bmaptool"
839 839 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
840 840
841 841 # Image was successfully created
842 842 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
843 843
844 844 # Create qemu qcow2 image
845 845 if [ "$ENABLE_QEMU" = true ] ; then
846 846 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
847 847 QEMU_SIZE=16G
848 848
849 849 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
850 850 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
851 851
852 852 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
853 853 fi
854 854 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant